#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "M_ActivitySmashEggCFG.h"
std::auto_ptr<M_ActivitySmashEggCFG> M_ActivitySmashEggCFG::msSingleton(nullptr);

int M_ActivitySmashEggCFG::GetCount()
{
	return (int)mMapData.size();
}

const M_ActivitySmashEggCFGData* M_ActivitySmashEggCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, M_ActivitySmashEggCFGData>& M_ActivitySmashEggCFG::GetMapData()
{
	return mMapData;
}

void M_ActivitySmashEggCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/M_ActivitySmashEggCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		M_ActivitySmashEggCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mEggName = element->Attribute("EggName");
		data.mHammerId = element->IntAttribute("HammerId");
		data.mHammerCount = element->IntAttribute("HammerCount");
		data.mIntegralId = element->IntAttribute("IntegralId");
		data.mIntegralCount = element->IntAttribute("IntegralCount");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("M_ActivitySmashEggCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySmashEggCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/M_ActivitySmashEggCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "M_ActivitySmashEggCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		M_ActivitySmashEggCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readString(L, "EggName", data.mEggName);
		LuaCfgHelper::readInt(L, "HammerId", data.mHammerId);
		LuaCfgHelper::readInt(L, "HammerCount", data.mHammerCount);
		LuaCfgHelper::readInt(L, "IntegralId", data.mIntegralId);
		LuaCfgHelper::readInt(L, "IntegralCount", data.mIntegralCount);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("M_ActivitySmashEggCFG Loaded. Load Data:%u", mMapData.size());
}

void M_ActivitySmashEggCFG::Reload()
{
	mMapData.clear();
	Load();
}

M_ActivitySmashEggCFG* M_ActivitySmashEggCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new M_ActivitySmashEggCFG());
	}
	return msSingleton.get();
}

void M_ActivitySmashEggCFG::Release()
{
	msSingleton.reset(nullptr);
}
